# source('R/code regionaal/verkrijg_info_spreiding_regios.R')
rm(list=setdiff(ls(), "df_besmettingen_tot"))
source('R/utils.R')
source('R/DES.R')
source('R/get_system_information.R')
source('R/code_regionaal/strategieën_verplaatsingen_regionaal.R')
source('R/code_regionaal/voorspel_regionale_instroom.R')

strategien = list(  'CHOIR' = original_beleid_CHOIR,'plek' = beleid_nav_plek, 'beddenaantal' = beleid_nav_beddenaantal, 'beddenaantal_0' = beleid_nav_beddenaantal_0, 'beddenaantal_1' = beleid_nav_beddenaantal_1)#

lijst_kpis = list()
lijst_info = list()
Mtot = 250

evaluatie_horizon   = 60         #dagen 
bedden_vrijgehouden = 2
end_evaluatie       = as.Date('2021-01-07')
start_evaluatie     = end_evaluatie - days(evaluatie_horizon) + hours(10)
tussentijds_opslaan = T
horizon = 3

pad = paste0('regionale_info/simulaties spreiding regionaal/simulaties_spreiding_regios_hor=',toString(horizon)) 
app = '_1'
i=1
while(file.exists(paste0(pad, app, '.rds'))){
  i=i+1
  app = paste0('_',i)
}

# uit LCPS dagrapportage
# voor IC capaciteit en bezettingslide 7: capaciteit voor COVID op IC is percentage totale bezetting (Excl boss) door COVID-19 keer totale capaciteit,
# bez is aangegeven bezetting
# oost IC: cap 106*55/86 = 68 bez 55   
# brabant IC: cap 181*92/168=99 bez 92
# west ic:  cap 118*63/111=77, bez 63
# zwolle ic: cap 95*47/98 = 46 , bez = 45
# midden ic: cap 106*59/112 = 59, bez = 58

#slide 14 neem gemiddelde van capaciteit, percentage COVID is vastgezet op 1/6 (volgt ongv uit slide 11)
# de bezetting is gelijk aan bezetting op 1-7 in slide 12
# oost KL: cap = mean(1143,1120, 1200, 1184, 1196, 1214)/6 = 196, bez 155   
# brabant kl cap = mean(2048, 2052, 2100, 2128, 2122, 2147)/6 = 350, bez 308
# west kl cap = mean(946,947,1393,1141,1132,1131)/6 = 186 bez 183
# zwolle kl cap = mean(c(1013,1010,1148,1173,1281,1188))/6 = 189, bez 145
# middden kl cap = mean(c(979,931,999,1092,1165,1189))/6 = 177, bez 151
# 
# dit moet er minimaal uit komen qua overplaatsingen, ik neem 60/108 keer (nav aantal dagen evaluatie)
# het minimum van de in/uitplaatsingen op slide 17 per regio
# overpl: 108 days naar 60
# brabant ic 17/108*60 = 9, kl 22/108*60 = 12
# west ic  22/108*60 =12, kl 26/108*60 = 14
# oost ic 22/108*60 = 12, kl 86/108*60 = 48
# zwolle ic 16/108*60 = 9, kl 59/108*60 = 33
# midden ic 27/108*60 = 15, kl = 10/108*60 = 6
#anderzijds, ongv 45 van ic en 80 van kliniek

# óf dit moet er maximaal uit komen qua overplaatsingen, ik neem 60/108 keer (nav aantal dagen evaluatie)
# de uitplaatsingen op slide 17 per regio
# overpl: 108 days naar 60
# brabant ic 70/108*60 = 39, kl 184/108*60 = 102
# west ic  59/108*60 =33, kl 284/108*60 = 158
# oost ic 22/108*60 = 12, kl 86/108*60 = 48
# zwolle ic 16/108*60 = 9, kl 59/108*60 = 33
# midden ic 27/108*60 = 15, kl = 10/108*60 = 6
#anderzijds, ongv 90 van ic en 330 van kliniek

#dus gemiddeld
# oost ic 22/108*60 = 12, kl 86/108*60 = 48
# brabant ic 70/108*60 = 24, kl 184/108*60 = 57
# west ic  59/108*60 =23, kl 284/108*60 = 86
# zwolle ic 16/108*60 = 9, kl 59/108*60 = 33
# midden ic 27/108*60 = 15, kl = 10/108*60 = 6
#anderzijds, ongv 70 van ic en 200 van kliniek

#params
regios = c('Acute Zorgregio Oost', 'Netwerk Acute Zorg Brabant',
           'Netwerk Acute Zorg West', "Traumazorgnetwerk Midden-Nederland")

#lijst met huidige bezetting en capaciteit
huidige_capaciteitsdata_regios = list(`Acute Zorgregio Oost`       = list(bezetting = list(IC = 55, Kliniek = 155),
                                                                          capaciteit = list(IC =61, Kliniek = 183),
                                                                          alpha_levels = list(IC = 0.9, Kliniek =0.9)), 
                                      `Netwerk Acute Zorg Brabant` = list(bezetting = list(IC =92, Kliniek =305),
                                                                          capaciteit = list(IC = 165, Kliniek = 371),
                                                                          alpha_levels = list(IC = 0.9, Kliniek =0.9)),
                                      `Netwerk Acute Zorg West`    = list(bezetting = list(IC = 63, Kliniek = 162),
                                                                          capaciteit = list(IC = 114, Kliniek = 212),
                                                                          alpha_levels = list(IC = 0.9, Kliniek =0.9)),
                                      `Traumazorgnetwerk Midden-Nederland` = list(bezetting = list(IC = 58, Kliniek = 151),
                                                                                  capaciteit = list(IC = 80, Kliniek = 170),
                                                                                  alpha_levels = list(IC = 0.9, Kliniek = 0.9))
)

#definieer  transportkosten
kosten_transport  = rbind(c(10, 50, 50,10, 100), 
                          c(50, 10, 10,50, 100), 
                          c(50, 10, 10,50, 100), 
                          c(10, 50, 50,10, 100),
                          c(100, 100, 100, 100,100))

row.names(kosten_transport) = c(regios, 'Buitenland')
colnames(kosten_transport) = c(regios, 'Buitenland')

# Check the version of Python. (Dit moet aan het begin van het gehele R script een keer gebeuren)
py_config()
cores <- detectCores(logical = FALSE)
cl <- makeCluster(cores)
registerDoParallel(cl, cores=cores)

# Load .py file met daarin de optimalisatie functie
source_python("Python/Decision_optimization_program_callable_from_R.py")
source_python("Python/original_Decision_optimization_program_callable_from_R.py")



simuleerdata_init = list()
for(regio in regios){
  simuleerdata_regio = load_obj(paste0('regionale_info/',regio,'.rds')) # als dit niet bestaat, run dan "verkrijg_info_ziekenhuis.R" met nieuwe data
  
  #kans overplaatsing bepalen
  kans_kl_ic  = max(simuleerdata_regio$condprobs_kl_ic_gbhbp$est$ligduur_01)  #aanname dat pat geen bhbp heeft
  kans_ic_kl  = max(simuleerdata_regio$condprobs_ic_kl$est$ligduur_01)
  
  #info huidige patienten bepalen, data_nieuwe_pat_kliniek is de lijst aan data die je zou verwachten als een patiënt die dag is binnengekomen op de kliniek, nodige data om pad te sim
  huidige_bezetting_regio = huidige_capaciteitsdata_regios[[regio]]$bezetting
  data_nieuwe_pat_kl      = list(list(LOS_init = 1, department = 'Kliniek', prob_types = list(pat_KL_IC = kans_kl_ic, pat_KL_rest = 1 - kans_kl_ic), transferred_before = F))
  data_nieuwe_pat_ic      = list(list(LOS_init = 1, department = 'IC', prob_types = list(pat_IC_KL = kans_ic_kl, pat_IC_rest = 1 - kans_ic_kl), transferred_before = F))
  
  #init data is aantal nieuwe pat bij kliniek en ic
  data_start_pat_kl = data_nieuwe_pat_kl
  data_start_pat_kl[[1]]$arrival_time = start_evaluatie 
  data_start_pat_ic = data_nieuwe_pat_ic
  data_start_pat_ic[[1]]$arrival_time = start_evaluatie
  
  current_patient_info = append(rep(data_start_pat_kl, huidige_bezetting_regio$Kliniek),
                                rep(data_start_pat_ic, huidige_bezetting_regio$IC))
  
  #combineer in totale lijst
  simuleerdata_init[[regio]] = append(simuleerdata_regio, list(`current_patient_info`  = current_patient_info, 
                                                                 bezetting               = huidige_capaciteitsdata_regios[[regio]]$bezetting,
                                                                 capaciteit              = huidige_capaciteitsdata_regios[[regio]]$capaciteit,
                                                                 data_nieuwe_pat_kl      = data_nieuwe_pat_kl,
                                                                 data_nieuwe_pat_ic      = data_nieuwe_pat_ic,
                                                                 data_besmettingen       = simuleerdata_regio$data_besmettingen,
                                                                 kans_naar_ic            = simuleerdata_regio$perc_ic,
                                                                 alpha_levels            = huidige_capaciteitsdata_regios[[regio]]$alpha_levels))
  
}


for(m in seq(Mtot)){
  timenum = as.numeric(Sys.time())
  set.seed(timenum)
  randomseed = .Random.seed
  seed_info = list(seed =timenum, randomseed = randomseed)
  
  
  #bepaal aankomsten voor elke regio
  dfs_aankomsten  = list()
  for(regio in regios){
    simuleerdata = simuleerdata_init[[regio]] # laad data om te simuleren voor regio
    #sample aankomsten voor elk patiënt-type vooraf, resultaat is een reeks ptypen en als rij-namen de relatieve aankomsttijden tov start_datumtijd
    
    # verkrijg info over aankomsten, "echte" aankomstintensiteit is EWMA over echte aankomsten
    preds_ic = simuleerdata$preds_opnames_ic %>% filter(as.Date(datum) %in% seq(as.Date(start_evaluatie), as.Date(end_evaluatie) + days(2), by = 'days'))
    preds_kl = simuleerdata$preds_opnames_kl %>% filter(as.Date(datum) %in% seq(as.Date(start_evaluatie), as.Date(end_evaluatie) + days(2), by = 'days'))

    #schaal intensiteit ewma opn op om het nog een beetje spannend te maken
    preds_ic$ewma_opn = preds_ic$ewma_opn*simuleerdata$ic_opschaling
    preds_kl$ewma_opn = preds_kl$ewma_opn*simuleerdata$kliniek_opschaling
    
    #verkrijg intensiteitsfuncties Poisson proces (nodig voor sim)
    list_scenario_arrival_rates = get_arrival_rates(preds_ic = preds_ic, preds_kl = preds_kl, departure_info = simuleerdata$departure_info)
    
    # #aankomstintensiteit bepalen voor evaluatie, Poisson proces rondom EWMA rondom de echte opnamen in die periode
    # patienttype_info = simuleerdata$patienttype_info
    # patienttype_info$pat_KL_IC$arrival_info   = list_scenario_arrival_rates$ewma_opn$KL_IC
    # patienttype_info$pat_KL_rest$arrival_info = list_scenario_arrival_rates$ewma_opn$KL_rest
    # patienttype_info$pat_IC_KL$arrival_info   = list_scenario_arrival_rates$ewma_opn$IC_KL
    # patienttype_info$pat_IC_rest$arrival_info = list_scenario_arrival_rates$ewma_opn$IC_rest
    
    df_aankomsten = c()
    for(ptype in names(list_scenario_arrival_rates$ewma_opn)){
      ar_ptype           = list_scenario_arrival_rates$ewma_opn[[ptype]]
      path               = sample_path_nhpois(evaluatie_horizon + 1 + 10/24, ar_ptype$cuml_intensity_NHPP, ar_ptype$icuml_intensity_NHPP, cur_time = 10/24) 
      path[,1]           = rep(ptype, nrow(path))
      df_aankomsten      = rbind(df_aankomsten, path)
    }
    df_aankomsten = cbind(df_aankomsten, as.Date(start_evaluatie) + ddays(as.numeric(row.names(df_aankomsten))))
    dfs_aankomsten[[regio]] = df_aankomsten
  }
  
  for(naam_strategie in names(strategien)){
    set.seed(timenum)
    .Random.seed = randomseed
    
    strategie = strategien[[naam_strategie]]
    
    pat_opnieuw_verpl_kl = zeros(1, length(regios))
    pat_opnieuw_verpl_ic = zeros(1, length(regios))
    names(pat_opnieuw_verpl_kl) = regios
    names(pat_opnieuw_verpl_ic) = regios
    
    #maak initiele state van het systeem
    simuleerdata_regios = simuleerdata_init 
    
    #init dfs voor opslag
    df_bezetting_na_verpl   = as_tibble(t(unlist(huidige_capaciteitsdata_regios[regios]))) %>% select(contains('bezetting')) # df om verloop bezetting bij te houden
    df_bezetting_voor_verpl = as_tibble(t(unlist(huidige_capaciteitsdata_regios[regios]))) %>% select(contains('bezetting')) # df om verloop bezetting bij te houden
    df_capaciteit           = as_tibble(t(unlist(simuleerdata_regios))) %>% select(contains('.capaciteit.'))
    
    # df om verloop overplaatsingen bij te houden
    df_overplaatsingen_ic = c()
    df_overplaatsingen_kl = c()
    
    #init totaal df met alle nodige verplaatsingen
    df_nodige_verplaatsingen_ic = c()
    df_nodige_verplaatsingen_kl = c()
    
    dates           = c()
    huidig_tijdstip = start_evaluatie
    while(huidig_tijdstip <= end_evaluatie+ hours(10)){
      # print(paste0('sim = ',m,', strategie = ', naam_strategie,', tijd = ', huidig_tijdstip))
      write(paste0('sim = ',m,', strategie = ', naam_strategie,', tijd = ', huidig_tijdstip), paste0('regionale_info/simulaties spreiding regionaal/progress_spreiding_regios_hor=',toString(horizon),'.txt'))
      
      nodige_verplaatsingen_ic = c()
      nodige_verplaatsingen_kl = c()
      
      #definieer lege verplaatsingsmatrices
      namen_regios = c(regios, 'Buitenland')
      verplaatsingsmatrix_kl = as.data.frame(zeros(length(regios)+1, length(regios)+1))
      verplaatsingsmatrix_ic = as.data.frame(zeros(length(regios)+1, length(regios)+1))
      colnames(verplaatsingsmatrix_ic) = namen_regios
      row.names(verplaatsingsmatrix_ic) = namen_regios
      colnames(verplaatsingsmatrix_kl) = namen_regios
      row.names(verplaatsingsmatrix_kl) = namen_regios
      
      ##simuleer bezetting 1 dag vooruit
      for(regio in regios){
        simuleerdata = simuleerdata_regios[[regio]] # laad data om te simuleren voor regio
        
        df_aankomsten = dfs_aankomsten[[regio]]
        aankomsten_tussen_nu_morgen = df_aankomsten[(df_aankomsten[,2] > huidig_tijdstip) & (df_aankomsten[,2] <= huidig_tijdstip + days(1)), ]
        
        #stel voor elke pat een vaste aankomsttijd in
        patienttype_info = simuleerdata$patienttype_info
        if(nrow(aankomsten_tussen_nu_morgen)>0){
          for(ptype in names(patienttype_info)){
            aankomsten_ptype = sort(as.numeric(difftime(aankomsten_tussen_nu_morgen[sapply(aankomsten_tussen_nu_morgen[,1], function(name){grepl(name, ptype)}),2], as.Date(huidig_tijdstip), unit = 'day')))
            patienttype_info[[ptype]]$arrival_info = list(cuml_intensity_NHPP = get_function_next(aankomsten_ptype),
                                                          icuml_intensity_NHPP = Inf)
          }}else{
            for(ptype in names(patienttype_info)){
              patienttype_info[[ptype]]$arrival_info = zero_intensity_info()
            }
          }
        
        #simuleer 1 dag vooruit op uurbasis
        simresult = perform_DES(horizon = 1, department_names = c('Kliniek', 'IC'), patienttype_info = patienttype_info, 
                                current_patient_info = simuleerdata$current_patient_info, 
                                start_datetime = huidig_tijdstip, return_list_pat_sys = T)
        
        ##volgende dag
        # nieuwe gedetailleerde bezetting bepalen.
        # voor alle patiënten is de departure time relatief tot vorig simuleermoment uitgerekend, daarom trekken we er voor de volgende dag (nu dus) 1 dag vanaf
        current_patient_info = list()
        for(patient in simresult$remaining_patients){
          patient$departure_time = patient$departure_time-1 
          patient$LOS_init       = patient$LOS_init + 1
          current_patient_info = append(current_patient_info , list(patient))
        }
        
        #bereken nieuwe bezetting
        current_patient_info_kl   = current_patient_info[lapply(current_patient_info, function(list2){list2$department}) == 'Kliniek']
        bezetting_kl_regio        = length(current_patient_info_kl)
        
        current_patient_info_ic   = current_patient_info[lapply(current_patient_info, function(list2){list2$department}) == 'IC']
        bezetting_ic_regio        = length(current_patient_info_ic)
        
        #haal capaciteit op
        capaciteit_kl_regio = simuleerdata$capaciteit$Kliniek
        capaciteit_ic_regio = simuleerdata$capaciteit$IC
        
        # bereken nodige verplaatsingen, sla op in vector
        nodige_verplaatsingen_ic_regio = max(0, bezetting_ic_regio - capaciteit_ic_regio)
        nodige_verplaatsingen_ic       = c(nodige_verplaatsingen_ic, nodige_verplaatsingen_ic_regio) #excess = max(0, bez - capa)
        
        nodige_verplaatsingen_kl_regio = max(0, bezetting_kl_regio - capaciteit_kl_regio)
        nodige_verplaatsingen_kl       = c(nodige_verplaatsingen_kl, nodige_verplaatsingen_kl_regio)
        
        
        # verwijder overgeplaatste pat alvast uit het systeem, we weten toch al dat ze overgeplaatst gaan worden dus data kan er uit
        if(nodige_verplaatsingen_kl_regio>0){
          aankomsttijden_pat_kl       = as.POSIXct(sapply(current_patient_info_kl, function(list2){toString(list2$arrival_time)}), tz = 'UTC')
          aankomsttijden_pat_kl_ord   = order(aankomsttijden_pat_kl)                                     # indices  vroegste naar laatste aankomsten 
          idx_pat_kl_na_weghalen      = head(aankomsttijden_pat_kl_ord, -nodige_verplaatsingen_kl_regio) # haal indices laatst aangekomen pat weg gelijk aan aantal dat weggaat
          pat_opnieuw_verpl_kl[regio] = pat_opnieuw_verpl_kl[regio]  + sum(sapply(current_patient_info_kl[tail(aankomsttijden_pat_kl_ord, nodige_verplaatsingen_kl_regio)], function(lst){lst$transferred_before}))
          current_patient_info_kl     = current_patient_info_kl[idx_pat_kl_na_weghalen]                  # huidige pat = huidige pat - weggestuurd
        }
        if(nodige_verplaatsingen_ic_regio>0){
          aankomsttijden_pat_ic       = as.POSIXct(sapply(current_patient_info_ic, function(list2){toString(list2$arrival_time)}), tz = 'UTC')
          aankomsttijden_pat_ic_ord   = order(aankomsttijden_pat_ic)                                     # indices  vroegste naar laatste aankomsten 
          idx_pat_ic_na_weghalen      = head(aankomsttijden_pat_ic_ord, -nodige_verplaatsingen_ic_regio) # haal indices laatst aangekomen pat weg gelijk aan aantal dat weggaat
          pat_opnieuw_verpl_ic[regio] = pat_opnieuw_verpl_ic[regio]  + sum(sapply(current_patient_info_ic[tail(aankomsttijden_pat_ic_ord, nodige_verplaatsingen_ic_regio)], function(lst){lst$transferred_before}))
          current_patient_info_ic     = current_patient_info_ic[idx_pat_ic_na_weghalen]                  # huidige pat = huidige pat - weggestuurd
          
        }
        current_patient_info      = append(current_patient_info_ic, current_patient_info_kl)
        
        #bereken nieuwe bezetting
        bezetting_ic_regio        = length(current_patient_info_ic)
        bezetting_kl_regio        = length(current_patient_info_kl)
        
        #update simuleerdata
        simuleerdata_regios[[regio]]$bezetting = list(IC = bezetting_ic_regio, Kliniek = bezetting_kl_regio)
        simuleerdata_regios[[regio]]$current_patient_info = current_patient_info #update data huidige pat
      }
      
      #zet tijdstip naar volgende dag
      huidig_tijdstip = huidig_tijdstip + days(1)
      
      #regios koppelen aan nodige verpl
      nodige_verplaatsingen_ic           = t(as.data.frame(nodige_verplaatsingen_ic))
      nodige_verplaatsingen_kl           = t(as.data.frame(nodige_verplaatsingen_kl))
      colnames(nodige_verplaatsingen_ic) = regios
      colnames(nodige_verplaatsingen_kl) = regios
      
      ## plaats pat in bij bestemmingen
      if(sum(nodige_verplaatsingen_kl )>0 | sum(nodige_verplaatsingen_ic)>0 ){
        temp_randomseed = .Random.seed
        #bepaal verplaatsingen adhv gekozen strategie (zie begin file)
        tic()
        verplaatsingsmatrices = strategie(huidig_tijdstip, nodige_verplaatsingen_ic, nodige_verplaatsingen_kl, simuleerdata_regios, kosten_transport, seed_info, horizon = horizon,
                                          bedden_vrijgehouden = bedden_vrijgehouden)
        toc()
        .Random.seed = temp_randomseed
        
        #verwerk de verplaatsingen voor kliniek en IC
        verplaatsingsmatrix_kl = verplaatsingsmatrices$verplaatsingsmatrix_kl
        verplaatsingsmatrix_ic = verplaatsingsmatrices$verplaatsingsmatrix_ic
        
        #check dat de verplaatsingen de tekorten oplossen
        assertthat::assert_that(norm(nodige_verplaatsingen_kl - head(apply(t(verplaatsingsmatrix_kl),2,sum), -1))==0)
        assertthat::assert_that(norm(nodige_verplaatsingen_ic - head(apply(t(verplaatsingsmatrix_ic),2,sum), -1))==0)
        
        for(regio in regios){
          simuleerdata_regio = simuleerdata_regios[[regio]]
          
          #voeg nieuwe patiënten kl/ic toe bij de regios waar patiënten naartoe zijn verplaatst
          aantal_nieuwe_pat_regio_ic                        = sum(verplaatsingsmatrix_ic[, regio])
          aantal_nieuwe_pat_regio_kl                        = sum(verplaatsingsmatrix_kl[, regio])
          
          #check dat het past
          assertthat::assert_that(simuleerdata_regios[[regio]]$bezetting$IC + aantal_nieuwe_pat_regio_ic      <= simuleerdata_regio$capaciteit$IC & 
                                    simuleerdata_regios[[regio]]$bezetting$Kliniek + aantal_nieuwe_pat_regio_kl <= simuleerdata_regio$capaciteit$Kliniek, 
                                  msg = paste0('geplande bezetting zit boven capaciteit in regio ', regio))
          
          #verwerk nieuwe pat ic
          data_huidig_pat_ic                                = simuleerdata_regio$data_nieuwe_pat_ic
          data_huidig_pat_ic[[1]]$arrival_time              = huidig_tijdstip
          data_huidig_pat_ic[[1]]$transferred_before        = T
          simuleerdata_regios[[regio]]$current_patient_info = append( simuleerdata_regios[[regio]]$current_patient_info, rep(data_huidig_pat_ic, aantal_nieuwe_pat_regio_ic))
          
          #verwerk nieuwe pat kl
          data_huidig_pat_kl                                = simuleerdata_regio$data_nieuwe_pat_kl
          data_huidig_pat_kl[[1]]$arrival_time              = huidig_tijdstip
          data_huidig_pat_kl[[1]]$transferred_before        = T
          simuleerdata_regios[[regio]]$current_patient_info = append( simuleerdata_regios[[regio]]$current_patient_info, rep(data_huidig_pat_kl, aantal_nieuwe_pat_regio_kl))
          
          #update ook de bezetting
          bezetting_ic_regio = simuleerdata_regio$bezetting$IC
          bezetting_kl_regio = simuleerdata_regio$bezetting$Kliniek
          simuleerdata_regios[[regio]]$bezetting = list(IC      = bezetting_ic_regio + aantal_nieuwe_pat_regio_ic, 
                                                        Kliniek = bezetting_kl_regio + aantal_nieuwe_pat_regio_kl)
        }}
      
      
      # sla bezetting over tijd op in df
      bezetting_dag_voor_verpl = c() #bezetting voordat er verplaatst werd
      bezetting_dag_na_verpl   = c()
      for(regio in regios){
        #bereken huidige bezetting in regio
        bezetting_dag_na_verpl = c(bezetting_dag_na_verpl, c( simuleerdata_regios[[regio]]$bezetting$IC,
                                                              simuleerdata_regios[[regio]]$bezetting$Kliniek))
        
        #bereken huidige bezetting in regio vóór verplaatsingen
        bezetting_dag_voor_verpl = c(bezetting_dag_voor_verpl, c( simuleerdata_regios[[regio]]$bezetting$IC      - sum(verplaatsingsmatrix_ic[,regio]) + nodige_verplaatsingen_ic[,regio] ,
                                                                  simuleerdata_regios[[regio]]$bezetting$Kliniek - sum(verplaatsingsmatrix_kl[,regio]) + nodige_verplaatsingen_kl[,regio] ))
        
      } 
      df_bezetting_na_verpl   = rbind(df_bezetting_na_verpl, bezetting_dag_na_verpl) #combi data bezetting
      df_bezetting_voor_verpl = rbind(df_bezetting_voor_verpl, bezetting_dag_voor_verpl)
      
      #hou nodige verplaatsingen bij
      df_nodige_verplaatsingen_kl = rbind(df_nodige_verplaatsingen_kl, nodige_verplaatsingen_kl)
      df_nodige_verplaatsingen_ic = rbind(df_nodige_verplaatsingen_ic, nodige_verplaatsingen_ic)
      
      #hou overplaatsingen van herkomst naar bestemming bij
      dates                 = c(dates, toString(huidig_tijdstip))
      df_overplaatsingen_ic = rbind(df_overplaatsingen_ic, head(as.vector(t(as.matrix(verplaatsingsmatrix_ic))), -length(regios)-1))
      df_overplaatsingen_kl = rbind(df_overplaatsingen_kl, head(as.vector(t(as.matrix(verplaatsingsmatrix_kl))), -length(regios)-1))
    }
    #maak tbl van overplaatsingen met datum
    colnames_to_use = c('datum', as.vector(sapply(head(namen_regios, -1), function(naam){sapply(namen_regios,function(naam2){paste0('van ',naam,' naar ',naam2)})})))
    df_overplaatsingen_ic = as_tibble(df_overplaatsingen_ic) %>% add_column(datum = as.Date(dates), .before = 1)
    colnames(df_overplaatsingen_ic) = colnames_to_use
    df_overplaatsingen_kl = as_tibble(df_overplaatsingen_kl) %>% add_column(datum = as.Date(dates), .before = 1)
    colnames(df_overplaatsingen_kl) = colnames_to_use
    
    #voeg datums toe aan df met nodige overplaatsingen
    df_nodige_verplaatsingen_kl = as_tibble(df_nodige_verplaatsingen_kl) %>% add_column(datum = as.Date(dates), .before = 1)
    df_nodige_verplaatsingen_ic = as_tibble(df_nodige_verplaatsingen_ic) %>% add_column(datum = as.Date(dates), .before = 1)
    
    #maak tbl van (opgeloste) bezetting met datum
    dates = c( toString(start_evaluatie), dates)
    df_bezetting_na_verpl   = as_tibble(df_bezetting_na_verpl) %>% add_column(datum = as.Date(dates), .before = 1)
    df_bezetting_voor_verpl = as_tibble(df_bezetting_voor_verpl) %>% add_column(datum = as.Date(dates), .before = 1)
    
    capaciteitsdata = t(unlist(lapply(huidige_capaciteitsdata_regios , function(list2){list2$capaciteit})))
    
    #bepaal kpi
    cost_vector = head(as.vector(t(as.matrix(kosten_transport))), -length(regios)-1)
    balansval = apply(1 - as.matrix(df_bezetting_na_verpl %>% select(-datum))/ones(length(dates),1)%*%capaciteitsdata,2, function(x){sum(x^2)})
    balansval_ic = sum(balansval[seq(1,length(regios)*2,2)])
    balansval_kl = sum(balansval[seq(2,length(regios)*2,2)])
    kpis = rbind( c( sum(as.data.frame(df_overplaatsingen_ic)[,-1]), sum(as.data.frame(df_overplaatsingen_kl)[,-1])),
                  c( sum(as.data.frame(df_overplaatsingen_ic %>% select(contains('buitenland')))),
                     sum(as.data.frame(df_overplaatsingen_kl %>% select(contains('buitenland'))))),
                  c(balansval_ic,balansval_kl))
    row.names(kpis) = c('overplaatsingen tot', 'overplaatsingen bl', 'balans bedden over')
    colnames(kpis)  = c('ICU', 'Kliniek')
    
    row_kpis = matrix(kpis, nrow = 1)
    colnames(row_kpis) = as.vector(sapply(c('ICU', 'Kliniek'), function(s1){sapply(c('overplaatsingen tot', 'overplaatsingen bl', 'balans bedden over'), function(s2){paste(s1, s2)})}))
    
    lijst_kpis[[naam_strategie]] = rbind(lijst_kpis[[naam_strategie]], row_kpis)
    lijst_info[[naam_strategie]] = append(lijst_info[[naam_strategie]], list(list(bezetting_voor = df_bezetting_voor_verpl,
                                                                                  overplaatsingen_ic = df_overplaatsingen_ic,
                                                                                  overplaatsingen_kl = df_overplaatsingen_kl,
                                                                                  df_bezetting_na = df_bezetting_na_verpl,
                                                                                  seed_info = seed_info,
                                                                                  dfs_aankomsten = dfs_aankomsten,
                                                                                  kosten_transport = kosten_transport,
                                                                                  huidige_capaciteitsdata_regios = huidige_capaciteitsdata_regios,
                                                                                  nodige_verplaatsingen_ic = df_nodige_verplaatsingen_ic,
                                                                                  nodige_verplaatsingen_kl = df_nodige_verplaatsingen_kl,
                                                                                  simuleerdata_regio_init = simuleerdata_init,
                                                                                  pat_opnieuw_verpl_kl = pat_opnieuw_verpl_kl,
                                                                                  pat_opnieuw_verpl_ic = pat_opnieuw_verpl_ic
    )))
  }
  
  if(tussentijds_opslaan){
    res = mget(c('lijst_info', 'lijst_kpis' ))
    save(res, file = paste0(pad,app,'.rds'))
    if(m > 2 & mod(m,10)==0){#maak nieuwe file aan
      app = '_1'
      i=1
      while(file.exists(paste0(pad, app, '.rds'))){
        i=i+1
        app = paste0('_',i)
      }
      lijst_info = list()
      lijst_kpis = list()
    }
  }
}


