source('R/utils.R')

beleid_nav_plek = function(datumtijd, nodige_verplaatsingen_ic, nodige_verplaatsingen_kl, simuleerdata_regios, kosten_transport, seed_info, horizon = 3, bedden_vrijgehouden = 2, M = 1000){

  #verplaats patiënten naar regios waar plek is.
  #bepaal regios met  kliniek bedden vrij
  capaciteit_kl_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$Kliniek })
  bezetting_kl_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$Kliniek })
  vrije_plekken_kl_regios        = sapply(capaciteit_kl_regios - bezetting_kl_regios, function(x){max(x-bedden_vrijgehouden,0)})  # max(0, capa - bez)
  
  #lijst om bestemming uit te samplen, regio staat er in als er plek is
  lijst_vrije_plekken_kl         = Reduce(append, sapply(names(vrije_plekken_kl_regios), function(name){rep(name, ifelse(vrije_plekken_kl_regios[name]>0,1,0))})) 
  lijst_nodige_verplaatsingen_kl = Reduce(append, sapply(colnames(nodige_verplaatsingen_kl), function(name){rep(name, nodige_verplaatsingen_kl[,name])})) #lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix kliniek
  regios                            = c(names(vrije_plekken_kl_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_kl            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_kl)  = regios
  row.names(verplaatsingsmatrix_kl) = regios
  
  copy_nodige_verplaastingen_kl = nodige_verplaatsingen_kl
  while(sum(copy_nodige_verplaastingen_kl) > 0){
    if(length(lijst_vrije_plekken_kl) == 0){
      # als er geen vrije plekken meer zijn, stuur alles naar het buitenland
      verplaatsingsmatrix_kl[colnames(nodige_verplaatsingen_kl), 'Buitenland'] = t(copy_nodige_verplaastingen_kl)
      copy_nodige_verplaastingen_kl                                            = c(0)
    }else{
      #sample random patient en bestemming, verwerk in verplaatsingsmatrix
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_kl,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_kl,1)
      verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_kl                 = lijst_nodige_verplaatsingen_kl[-first(which(lijst_nodige_verplaatsingen_kl == regio_herkomst))]
      vrije_plekken_kl_regios[regio_bestemming]    = vrije_plekken_kl_regios[regio_bestemming] - 1
      if(vrije_plekken_kl_regios[regio_bestemming] <= bedden_vrijgehouden){
        lijst_vrije_plekken_kl                         = lijst_vrije_plekken_kl[-first(which(lijst_vrije_plekken_kl == regio_bestemming))]
      }
      copy_nodige_verplaastingen_kl[,regio_herkomst] = copy_nodige_verplaastingen_kl[,regio_herkomst] - 1
    }
  }
  
  ## zelfde weer voor ic
  #bepaal  # vrije plekken kliniek per regio
  capaciteit_ic_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$IC })
  bezetting_ic_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$IC })
  vrije_plekken_ic_regios        = sapply(capaciteit_ic_regios - bezetting_ic_regios, function(x){max(x-bedden_vrijgehouden,0)}) # max(0, capa - bez)
  lijst_vrije_plekken_ic         = Reduce(append, sapply(names(vrije_plekken_ic_regios), function(name){rep(name, ifelse(vrije_plekken_ic_regios[name]>0,1,0))}))  #lijst om bestemming uit te samplen
  lijst_nodige_verplaatsingen_ic = Reduce(append, sapply(colnames(nodige_verplaatsingen_ic), function(name){rep(name, nodige_verplaatsingen_ic[,name])}))#lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix ic
  regios                            = c(names(vrije_plekken_ic_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_ic            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_ic)  = regios
  row.names(verplaatsingsmatrix_ic) = regios
  
  copy_nodige_verplaatsingen_ic = nodige_verplaatsingen_ic
  while(sum(copy_nodige_verplaatsingen_ic) > 0){
    if(length(lijst_vrije_plekken_ic) ==0){
      # als er geen vrije plekken meer zijn stuur alles naar het buitenland
      verplaatsingsmatrix_ic[colnames(nodige_verplaatsingen_ic), 'Buitenland'] = t(copy_nodige_verplaatsingen_ic)
      copy_nodige_verplaatsingen_ic                                            = c(0)
    }else{
      #sample random patient en bestemming
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_ic,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_ic,1)
      verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_ic                 = lijst_nodige_verplaatsingen_ic[-first(which(lijst_nodige_verplaatsingen_ic == regio_herkomst))]
      vrije_plekken_ic_regios[ regio_bestemming]    = vrije_plekken_ic_regios[ regio_bestemming] - 1
      if(vrije_plekken_ic_regios[ regio_bestemming] <= bedden_vrijgehouden){
        lijst_vrije_plekken_ic                         = lijst_vrije_plekken_ic[-first(which(lijst_vrije_plekken_ic == regio_bestemming))]
      }
      copy_nodige_verplaatsingen_ic[,regio_herkomst] = copy_nodige_verplaatsingen_ic[,regio_herkomst] - 1
    }
  }
  return(list(verplaatsingsmatrix_kl = verplaatsingsmatrix_kl, verplaatsingsmatrix_ic = verplaatsingsmatrix_ic))
}

beleid_nav_beddenaantal = function(datumtijd, nodige_verplaatsingen_ic, nodige_verplaatsingen_kl, simuleerdata_regios, kosten_transport, seed_info, horizon = 3, bedden_vrijgehouden = 2, M = 1000){
  
  #verplaats pat naar regio waar plek is, met kans stijgend in het aantal vrije bedden
  #bepaal  # vrije plekken kliniek per regio
  capaciteit_kl_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$Kliniek })
  bezetting_kl_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$Kliniek })
  vrije_plekken_kl_regios        = sapply(capaciteit_kl_regios - bezetting_kl_regios, function(x){max(x-bedden_vrijgehouden,0)})  # max(0, capa - bez)
  
  #lijst om bestemming uit te samplen, regio wordt herhaald nav aantal vrije bedden
  lijst_vrije_plekken_kl         = Reduce(append, sapply(names(vrije_plekken_kl_regios), function(name){rep(name, vrije_plekken_kl_regios[name])})) 
  lijst_nodige_verplaatsingen_kl = Reduce(append, sapply(colnames(nodige_verplaatsingen_kl), function(name){rep(name, nodige_verplaatsingen_kl[,name])})) #lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix kliniek
  regios                            = c(names(vrije_plekken_kl_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_kl            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_kl)  = regios
  row.names(verplaatsingsmatrix_kl) = regios
  
  copy_nodige_verplaastingen_kl = nodige_verplaatsingen_kl
  while(sum(copy_nodige_verplaastingen_kl) > 0){
    if(length(lijst_vrije_plekken_kl) == 0){
      # als er geen vrije plekken meer zijn, stuur alles naar het buitenland
      verplaatsingsmatrix_kl[colnames(nodige_verplaatsingen_kl), 'Buitenland'] = t(copy_nodige_verplaastingen_kl)
      copy_nodige_verplaastingen_kl                                            = c(0)
    }else{
      #sample random patient en bestemming, verwerk in verplaatsingsmatrix
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_kl,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_kl,1)
      verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_kl                 = lijst_nodige_verplaatsingen_kl[-first(which(lijst_nodige_verplaatsingen_kl == regio_herkomst))]
      lijst_vrije_plekken_kl                         = lijst_vrije_plekken_kl[-first(which(lijst_vrije_plekken_kl == regio_bestemming))]
      
      #veiligheidsmarge
      if(length(lijst_vrije_plekken_kl) <= bedden_vrijgehouden){
        lijst_vrije_plekken_kl = list() #geef aan, geen vrije bedden
      }
      copy_nodige_verplaastingen_kl[,regio_herkomst] = copy_nodige_verplaastingen_kl[,regio_herkomst] - 1
    }
  }
  
  ## zelfde weer voor ic
  #bepaal  # vrije plekken kliniek per regio
  capaciteit_ic_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$IC })
  bezetting_ic_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$IC })
  vrije_plekken_ic_regios        = sapply(capaciteit_ic_regios - bezetting_ic_regios, function(x){max(x-bedden_vrijgehouden,0)}) # max(0, capa - bez)
  lijst_vrije_plekken_ic         = Reduce(append, sapply(names(vrije_plekken_ic_regios), function(name){rep(name, vrije_plekken_ic_regios[name])}))  #lijst om bestemming uit te samplen
  lijst_nodige_verplaatsingen_ic = Reduce(append, sapply(colnames(nodige_verplaatsingen_ic), function(name){rep(name, nodige_verplaatsingen_ic[,name])}))#lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix ic
  regios                            = c(names(vrije_plekken_ic_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_ic            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_ic)  = regios
  row.names(verplaatsingsmatrix_ic) = regios
  
  copy_nodige_verplaatsingen_ic = nodige_verplaatsingen_ic
  while(sum(copy_nodige_verplaatsingen_ic) > 0){
    if(length(lijst_vrije_plekken_ic) ==0){
      # als er geen vrije plekken meer zijn stuur alles naar het buitenland
      verplaatsingsmatrix_ic[colnames(nodige_verplaatsingen_ic), 'Buitenland'] = t(copy_nodige_verplaatsingen_ic)
      copy_nodige_verplaatsingen_ic                                            = c(0)
    }else{
      #sample random patient en bestemming
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_ic,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_ic,1)
      verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_ic                 = lijst_nodige_verplaatsingen_ic[-first(which(lijst_nodige_verplaatsingen_ic == regio_herkomst))]
      lijst_vrije_plekken_ic                         = lijst_vrije_plekken_ic[-first(which(lijst_vrije_plekken_ic == regio_bestemming))]
      
      #veiligheidsmarge
      if(length(lijst_vrije_plekken_ic) <= bedden_vrijgehouden){
        lijst_vrije_plekken_ic = list()
      }
      copy_nodige_verplaatsingen_ic[,regio_herkomst] = copy_nodige_verplaatsingen_ic[,regio_herkomst] - 1
    }
  }
  return(list(verplaatsingsmatrix_kl = verplaatsingsmatrix_kl, verplaatsingsmatrix_ic = verplaatsingsmatrix_ic))
}


beleid_CHOIR = function(huidig_tijdstip, nodige_verplaatsingen_ic, nodige_verplaatsingen_kl, simuleerdata_regios, kosten_transport,
                        seed_info, horizon = 3, M = 1000, bedden_vrijgehouden = 0){
  
  regios = names(simuleerdata_regios)
  
  #init dataframes met aantal vrije plekken en capaciteit IC en kliniek per regio
  tekort_overschot_toekomst_kl = as.data.frame(zeros(M, dim(nodige_verplaatsingen_ic)[2]))
  colnames(tekort_overschot_toekomst_kl) = colnames(nodige_verplaatsingen_kl)

  tekort_overschot_toekomst_ic = as.data.frame(zeros(M, dim(nodige_verplaatsingen_ic)[2]))
  colnames(tekort_overschot_toekomst_ic) = colnames(nodige_verplaatsingen_ic)
  tekort_overschot_huidig_ic = nodige_verplaatsingen_ic*0
  capaciteit_ic_regios = nodige_verplaatsingen_ic*0
  tekort_overschot_huidig_kl = nodige_verplaatsingen_kl*0
  capaciteit_kl_regios = nodige_verplaatsingen_kl*0
  
  for(regio in regios){
      #verkrijg data regio
      simuleerdata = simuleerdata_regios[[regio]]
      
      #vind huidige bezetting en capaciteit
      huidige_capaciteit_ic        = simuleerdata$capaciteit$IC
      capaciteit_ic_regios[,regio] = huidige_capaciteit_ic
      
      huidige_capaciteit_kl        = simuleerdata$capaciteit$Kliniek
      capaciteit_kl_regios[,regio] = huidige_capaciteit_kl
      
      huidige_bezetting_ic  = simuleerdata$bezetting$IC
      huidige_bezetting_kl  = simuleerdata$bezetting$Kliniek
      
      #reken huidig aantal plekken vrij uit, dit aantal kan negatief zijn als er een patient moet vertrekken
      plekken_Vrij_ic_huidig = huidige_capaciteit_ic - huidige_bezetting_ic - nodige_verplaatsingen_ic[,regio]
      plekken_Vrij_kl_huidig = huidige_capaciteit_kl - huidige_bezetting_kl - nodige_verplaatsingen_kl[,regio]
      
      tekort_overschot_huidig_kl[,regio]  = plekken_Vrij_kl_huidig
      tekort_overschot_huidig_ic[,regio]  = plekken_Vrij_ic_huidig
      
      # verkrijg besmettingsdata tot aan voorspelmoment en voorspel aankomsten
      data_besmettingen             = simuleerdata$data_besmettingen %>% filter(datum <= as.Date(huidig_tijdstip))
      voorspelde_regionale_instroom = quiet(fit_besmettingen_opnames(data_besmettingen , horizon = horizon +1 ) %>% filter(datum >= max(data_besmettingen$datum))) 
      
      #split in aankomsten IC en aankomsten kliniek, schaal op met zelfde constante als de echte aankomstintensiteit
      kans_naar_ic = simuleerdata$kans_naar_ic
      preds_ic      = voorspelde_regionale_instroom %>% select(datum, besmettingen) %>% mutate(besmettingen = simuleerdata$ic_opschaling*besmettingen*kans_naar_ic)
      preds_kl      = voorspelde_regionale_instroom %>% select(datum, besmettingen) %>% mutate(besmettingen = simuleerdata$kliniek_opschaling*besmettingen*(1-kans_naar_ic))
      
      #verkrijg intensiteitsfuncties Poisson proces
      list_scenario_arrival_rates = get_arrival_rates(preds_ic = preds_ic, preds_kl = preds_kl, departure_info = simuleerdata$departure_info)
      
      #aankomstintensiteit bepalen voor evaluatie, Poisson proces voorspellingen uit besmettingen
      patienttype_info                          = simuleerdata$patienttype_info
      patienttype_info$pat_KL_IC$arrival_info   = list_scenario_arrival_rates$besmettingen$KL_IC
      patienttype_info$pat_KL_rest$arrival_info = list_scenario_arrival_rates$besmettingen$KL_rest
      patienttype_info$pat_IC_KL$arrival_info   = list_scenario_arrival_rates$besmettingen$IC_KL
      patienttype_info$pat_IC_rest$arrival_info = list_scenario_arrival_rates$besmettingen$IC_rest
      
      current_patient_info = lapply(simuleerdata$current_patient_info, function(L){ 
        L$LOS = NULL
        L$seed = NULL
        L$departure_time = NULL
        return(L)})
      
      #maak voorspelling toekomstige bezetting
      simres_partial = foreach(icount(M), .combine = append, .export = c('perform_DES', 'rnhpois', 'sample_remaining_LOS',
                                                                        'first'), .packages = c('pracma','lubridate','dbplyr','tibble','tidyr','dplyr')) %dopar% {
                                                                           list(perform_DES(horizon, department_names =  c('Kliniek', 'IC'),
                                                                                            patienttype_info = patienttype_info, 
                                                                                            current_patient_info = current_patient_info, 
                                                                                            start_datetime = huidig_tijdstip, by_hour = F))}
  
      
      #bereken kwantielen maximale bezetting over sims
      maxima_ic = sapply(simres_partial, function(list2){max(list2$IC)})
      maxima_kl = sapply(simres_partial, function(list2){max(list2$Kliniek)})
      
      #reken toekomstig aantal plekken vrij uit, dit aantal kan negatief zijn als er een patient moet vertrekken
      plekken_Vrij_ic_toekomst = huidige_capaciteit_ic - maxima_ic - nodige_verplaatsingen_ic[,regio]
      plekken_Vrij_kl_toekomst = huidige_capaciteit_kl - maxima_kl - nodige_verplaatsingen_kl[,regio]
      
      tekort_overschot_toekomst_kl[,regio]  = plekken_Vrij_kl_toekomst
      tekort_overschot_toekomst_ic[,regio]  = plekken_Vrij_ic_toekomst
    
  }
  
  #reken verplaatsingen uit adhv MIQP
  
  opt_res = run_optimization_program_transferring_patient(as.numeric(capaciteit_kl_regios), as.numeric(capaciteit_ic_regios), as.numeric(tekort_overschot_huidig_kl),
                                                      as.numeric(tekort_overschot_huidig_ic), as.matrix(tekort_overschot_toekomst_kl), as.matrix(tekort_overschot_toekomst_ic), 
                                                      kosten_transport)
  
  #bepaal matrices overplaatsingen ic en kliniek
  namen_regios = c(regios, 'Buitenland')
  
  verplaatsingsmatrix_kl = opt_res[[1]]
  colnames(verplaatsingsmatrix_kl) = namen_regios
  row.names(verplaatsingsmatrix_kl) = namen_regios
  
  verplaatsingsmatrix_ic = opt_res[[2]]
  colnames(verplaatsingsmatrix_ic) = namen_regios
  row.names(verplaatsingsmatrix_ic) = namen_regios
  
  return(list(verplaatsingsmatrix_kl = verplaatsingsmatrix_kl, verplaatsingsmatrix_ic = verplaatsingsmatrix_ic))
}

original_beleid_CHOIR = function(huidig_tijdstip, nodige_verplaatsingen_ic, nodige_verplaatsingen_kl, simuleerdata_regios, kosten_transport,
                                 seed_info, horizon = 3, M = 1000, bedden_vrijgehouden = 0){
  # set.seed(as.numeric(Sys.time()))
  regios = names(simuleerdata_regios)
  
  #init dataframes met aantal vrije plekken en capaciteit IC en kliniek per regio
  tekort_overschot_toekomst_kl = nodige_verplaatsingen_kl*0
  tekort_overschot_toekomst_ic = nodige_verplaatsingen_ic*0
  tekort_overschot_huidig_ic = nodige_verplaatsingen_ic*0
  capaciteit_ic_regios = nodige_verplaatsingen_ic*0
  tekort_overschot_huidig_kl = nodige_verplaatsingen_kl*0
  capaciteit_kl_regios = nodige_verplaatsingen_kl*0
  
  for(regio in regios){
    #verkrijg data regio
    simuleerdata = simuleerdata_regios[[regio]]
    
    #vind huidige bezetting en capaciteit
    huidige_capaciteit_ic        = simuleerdata$capaciteit$IC
    capaciteit_ic_regios[,regio] = huidige_capaciteit_ic
    
    huidige_capaciteit_kl        = simuleerdata$capaciteit$Kliniek
    capaciteit_kl_regios[,regio] = huidige_capaciteit_kl
    
    huidige_bezetting_ic  = simuleerdata$bezetting$IC
    huidige_bezetting_kl  = simuleerdata$bezetting$Kliniek
    
    #reken huidig aantal plekken vrij uit, dit aantal kan negatief zijn als er een patient moet vertrekken
    plekken_Vrij_ic_huidig = huidige_capaciteit_ic - huidige_bezetting_ic - nodige_verplaatsingen_ic[,regio]
    plekken_Vrij_kl_huidig = huidige_capaciteit_kl - huidige_bezetting_kl - nodige_verplaatsingen_kl[,regio]
    
    tekort_overschot_huidig_kl[,regio]  = plekken_Vrij_kl_huidig
    tekort_overschot_huidig_ic[,regio]  = plekken_Vrij_ic_huidig
    
    # verkrijg besmettingsdata tot aan voorspelmoment en voorspel aankomsten
    data_besmettingen             = simuleerdata$data_besmettingen %>% filter(datum <= as.Date(huidig_tijdstip))
    voorspelde_regionale_instroom = quiet(fit_besmettingen_opnames(data_besmettingen , horizon = min(7,horizon +1) ) %>% filter(datum >= max(data_besmettingen$datum))) 
    
    #split in aankomsten IC en aankomsten kliniek, schaal op met zelfde constante als de echte aankomstintensiteit
    kans_naar_ic = simuleerdata$kans_naar_ic
    preds_ic      = voorspelde_regionale_instroom %>% select(datum, besmettingen) %>% mutate(besmettingen = simuleerdata$ic_opschaling*besmettingen*kans_naar_ic)
    preds_kl      = voorspelde_regionale_instroom %>% select(datum, besmettingen) %>% mutate(besmettingen = simuleerdata$kliniek_opschaling*besmettingen*(1-kans_naar_ic))
    
    #verkrijg intensiteitsfuncties Poisson proces
    list_scenario_arrival_rates = get_arrival_rates(preds_ic = preds_ic, preds_kl = preds_kl, departure_info = simuleerdata$departure_info)
    
    #aankomstintensiteit bepalen voor evaluatie, Poisson proces voorspellingen uit besmettingen
    patienttype_info                          = simuleerdata$patienttype_info
    patienttype_info$pat_KL_IC$arrival_info   = list_scenario_arrival_rates$besmettingen$KL_IC
    patienttype_info$pat_KL_rest$arrival_info = list_scenario_arrival_rates$besmettingen$KL_rest
    patienttype_info$pat_IC_KL$arrival_info   = list_scenario_arrival_rates$besmettingen$IC_KL
    patienttype_info$pat_IC_rest$arrival_info = list_scenario_arrival_rates$besmettingen$IC_rest
    
    current_patient_info = lapply(simuleerdata$current_patient_info, function(L){ 
      L$LOS = NULL
      L$seed = NULL
      L$departure_time = NULL
      return(L)})
    
    #maak voorspelling toekomstige bezetting
    simres_partial = foreach(icount(M), .combine = append, .export = c('perform_DES', 'rnhpois', 'sample_remaining_LOS',
                                                                       'first'), .packages = c('pracma','lubridate','dbplyr','tibble','tidyr','dplyr')) %dopar% {
                                                                         list(perform_DES(horizon, department_names =  c('Kliniek', 'IC'),
                                                                                          patienttype_info = patienttype_info, 
                                                                                          current_patient_info = current_patient_info, 
                                                                                          start_datetime = huidig_tijdstip, by_hour = F))}
    
    
    #bereken kwantielen maximale bezetting over sims
    kwantiel_maxima_ic = quantile(sapply(simres_partial, function(list2){max(list2$IC)}), simuleerdata$alpha_levels$IC)
    kwantiel_maxima_kl = quantile(sapply(simres_partial, function(list2){max(list2$Kliniek)}), simuleerdata$alpha_levels$Kliniek)
    
    #reken toekomstig aantal plekken vrij uit, dit aantal kan negatief zijn als er een patient moet vertrekken
    plekken_Vrij_ic_toekomst = huidige_capaciteit_ic - kwantiel_maxima_ic - nodige_verplaatsingen_ic[,regio]
    plekken_Vrij_kl_toekomst = huidige_capaciteit_kl - kwantiel_maxima_kl - nodige_verplaatsingen_kl[,regio]
    
    tekort_overschot_toekomst_kl[,regio]  = plekken_Vrij_kl_toekomst
    tekort_overschot_toekomst_ic[,regio]  = plekken_Vrij_ic_toekomst
    
  }
  
  #reken verplaatsingen uit adhv MIQP
  tic()
  opt_res = run_original_optimization_program_transferring_patient(as.numeric(capaciteit_kl_regios), as.numeric(capaciteit_ic_regios), as.numeric(tekort_overschot_huidig_kl),
                                                          as.numeric(tekort_overschot_huidig_ic), as.numeric(tekort_overschot_toekomst_kl), as.numeric(tekort_overschot_toekomst_ic), 
                                                          kosten_transport)
  toc()
  #bepaal matrices overplaatsingen ic en kliniek
  namen_regios = c(regios, 'Buitenland')
  
  verplaatsingsmatrix_kl = opt_res[[1]]
  colnames(verplaatsingsmatrix_kl) = namen_regios
  row.names(verplaatsingsmatrix_kl) = namen_regios
  
  verplaatsingsmatrix_ic = opt_res[[2]]
  colnames(verplaatsingsmatrix_ic) = namen_regios
  row.names(verplaatsingsmatrix_ic) = namen_regios
  
  return(list(verplaatsingsmatrix_kl = verplaatsingsmatrix_kl, verplaatsingsmatrix_ic = verplaatsingsmatrix_ic))
}

beleid_nav_beddenaantal_0 = function(datumtijd, nodige_verplaatsingen_ic, nodige_verplaatsingen_kl, simuleerdata_regios, kosten_transport, seed_info, horizon = 3, bedden_vrijgehouden = 0, M = 1000){
  bedden_vrijgehouden = 0
  #verplaats pat naar regio waar plek is, met kans stijgend in het aantal vrije bedden
  #bepaal  # vrije plekken kliniek per regio
  capaciteit_kl_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$Kliniek })
  bezetting_kl_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$Kliniek })
  vrije_plekken_kl_regios        = sapply(capaciteit_kl_regios - bezetting_kl_regios, function(x){max(x-bedden_vrijgehouden,0)})  # max(0, capa - bez)
  
  #lijst om bestemming uit te samplen, regio wordt herhaald nav aantal vrije bedden
  lijst_vrije_plekken_kl         = Reduce(append, sapply(names(vrije_plekken_kl_regios), function(name){rep(name, vrije_plekken_kl_regios[name])})) 
  lijst_nodige_verplaatsingen_kl = Reduce(append, sapply(colnames(nodige_verplaatsingen_kl), function(name){rep(name, nodige_verplaatsingen_kl[,name])})) #lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix kliniek
  regios                            = c(names(vrije_plekken_kl_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_kl            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_kl)  = regios
  row.names(verplaatsingsmatrix_kl) = regios
  
  copy_nodige_verplaastingen_kl = nodige_verplaatsingen_kl
  while(sum(copy_nodige_verplaastingen_kl) > 0){
    if(length(lijst_vrije_plekken_kl) == 0){
      # als er geen vrije plekken meer zijn, stuur alles naar het buitenland
      verplaatsingsmatrix_kl[colnames(nodige_verplaatsingen_kl), 'Buitenland'] = t(copy_nodige_verplaastingen_kl)
      copy_nodige_verplaastingen_kl                                            = c(0)
    }else{
      #sample random patient en bestemming, verwerk in verplaatsingsmatrix
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_kl,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_kl,1)
      verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_kl                 = lijst_nodige_verplaatsingen_kl[-first(which(lijst_nodige_verplaatsingen_kl == regio_herkomst))]
      lijst_vrije_plekken_kl                         = lijst_vrije_plekken_kl[-first(which(lijst_vrije_plekken_kl == regio_bestemming))]
      
      #veiligheidsmarge
      if(length(lijst_vrije_plekken_kl) <= bedden_vrijgehouden){
        lijst_vrije_plekken_kl = list() #geef aan, geen vrije bedden
      }
      copy_nodige_verplaastingen_kl[,regio_herkomst] = copy_nodige_verplaastingen_kl[,regio_herkomst] - 1
    }
  }
  
  ## zelfde weer voor ic
  #bepaal  # vrije plekken kliniek per regio
  capaciteit_ic_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$IC })
  bezetting_ic_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$IC })
  vrije_plekken_ic_regios        = sapply(capaciteit_ic_regios - bezetting_ic_regios, function(x){max(x-bedden_vrijgehouden,0)}) # max(0, capa - bez)
  lijst_vrije_plekken_ic         = Reduce(append, sapply(names(vrije_plekken_ic_regios), function(name){rep(name, vrije_plekken_ic_regios[name])}))  #lijst om bestemming uit te samplen
  lijst_nodige_verplaatsingen_ic = Reduce(append, sapply(colnames(nodige_verplaatsingen_ic), function(name){rep(name, nodige_verplaatsingen_ic[,name])}))#lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix ic
  regios                            = c(names(vrije_plekken_ic_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_ic            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_ic)  = regios
  row.names(verplaatsingsmatrix_ic) = regios
  
  copy_nodige_verplaatsingen_ic = nodige_verplaatsingen_ic
  while(sum(copy_nodige_verplaatsingen_ic) > 0){
    if(length(lijst_vrije_plekken_ic) ==0){
      # als er geen vrije plekken meer zijn stuur alles naar het buitenland
      verplaatsingsmatrix_ic[colnames(nodige_verplaatsingen_ic), 'Buitenland'] = t(copy_nodige_verplaatsingen_ic)
      copy_nodige_verplaatsingen_ic                                            = c(0)
    }else{
      #sample random patient en bestemming
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_ic,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_ic,1)
      verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_ic                 = lijst_nodige_verplaatsingen_ic[-first(which(lijst_nodige_verplaatsingen_ic == regio_herkomst))]
      lijst_vrije_plekken_ic                         = lijst_vrije_plekken_ic[-first(which(lijst_vrije_plekken_ic == regio_bestemming))]
      
      #veiligheidsmarge
      if(length(lijst_vrije_plekken_ic) <= bedden_vrijgehouden){
        lijst_vrije_plekken_ic = list()
      }
      copy_nodige_verplaatsingen_ic[,regio_herkomst] = copy_nodige_verplaatsingen_ic[,regio_herkomst] - 1
    }
  }
  return(list(verplaatsingsmatrix_kl = verplaatsingsmatrix_kl, verplaatsingsmatrix_ic = verplaatsingsmatrix_ic))
}

beleid_nav_beddenaantal_1 = function(datumtijd, nodige_verplaatsingen_ic, nodige_verplaatsingen_kl, simuleerdata_regios, kosten_transport, seed_info, horizon = 3, bedden_vrijgehouden = 1, M = 1000){
  bedden_vrijgehouden = 1
  #verplaats pat naar regio waar plek is, met kans stijgend in het aantal vrije bedden
  #bepaal  # vrije plekken kliniek per regio
  capaciteit_kl_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$Kliniek })
  bezetting_kl_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$Kliniek })
  vrije_plekken_kl_regios        = sapply(capaciteit_kl_regios - bezetting_kl_regios, function(x){max(x-bedden_vrijgehouden,0)})  # max(0, capa - bez)
  
  #lijst om bestemming uit te samplen, regio wordt herhaald nav aantal vrije bedden
  lijst_vrije_plekken_kl         = Reduce(append, sapply(names(vrije_plekken_kl_regios), function(name){rep(name, vrije_plekken_kl_regios[name])})) 
  lijst_nodige_verplaatsingen_kl = Reduce(append, sapply(colnames(nodige_verplaatsingen_kl), function(name){rep(name, nodige_verplaatsingen_kl[,name])})) #lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix kliniek
  regios                            = c(names(vrije_plekken_kl_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_kl            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_kl)  = regios
  row.names(verplaatsingsmatrix_kl) = regios
  
  copy_nodige_verplaastingen_kl = nodige_verplaatsingen_kl
  while(sum(copy_nodige_verplaastingen_kl) > 0){
    if(length(lijst_vrije_plekken_kl) == 0){
      # als er geen vrije plekken meer zijn, stuur alles naar het buitenland
      verplaatsingsmatrix_kl[colnames(nodige_verplaatsingen_kl), 'Buitenland'] = t(copy_nodige_verplaastingen_kl)
      copy_nodige_verplaastingen_kl                                            = c(0)
    }else{
      #sample random patient en bestemming, verwerk in verplaatsingsmatrix
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_kl,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_kl,1)
      verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_kl[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_kl                 = lijst_nodige_verplaatsingen_kl[-first(which(lijst_nodige_verplaatsingen_kl == regio_herkomst))]
      lijst_vrije_plekken_kl                         = lijst_vrije_plekken_kl[-first(which(lijst_vrije_plekken_kl == regio_bestemming))]
      
      #veiligheidsmarge
      if(length(lijst_vrije_plekken_kl) <= bedden_vrijgehouden){
        lijst_vrije_plekken_kl = list() #geef aan, geen vrije bedden
      }
      copy_nodige_verplaastingen_kl[,regio_herkomst] = copy_nodige_verplaastingen_kl[,regio_herkomst] - 1
    }
  }
  
  ## zelfde weer voor ic
  #bepaal  # vrije plekken kliniek per regio
  capaciteit_ic_regios           = sapply(simuleerdata_regios, function(List){List$capaciteit$IC })
  bezetting_ic_regios            = sapply(simuleerdata_regios, function(List){List$bezetting$IC })
  vrije_plekken_ic_regios        = sapply(capaciteit_ic_regios - bezetting_ic_regios, function(x){max(x-bedden_vrijgehouden,0)}) # max(0, capa - bez)
  lijst_vrije_plekken_ic         = Reduce(append, sapply(names(vrije_plekken_ic_regios), function(name){rep(name, vrije_plekken_ic_regios[name])}))  #lijst om bestemming uit te samplen
  lijst_nodige_verplaatsingen_ic = Reduce(append, sapply(colnames(nodige_verplaatsingen_ic), function(name){rep(name, nodige_verplaatsingen_ic[,name])}))#lijst om herkomst uit te samplen
  
  #init verplaatsingsmatrix ic
  regios                            = c(names(vrije_plekken_ic_regios) , 'Buitenland')
  aantal_regios                     = length(regios)
  verplaatsingsmatrix_ic            = as.data.frame(zeros(aantal_regios , aantal_regios))
  colnames(verplaatsingsmatrix_ic)  = regios
  row.names(verplaatsingsmatrix_ic) = regios
  
  copy_nodige_verplaatsingen_ic = nodige_verplaatsingen_ic
  while(sum(copy_nodige_verplaatsingen_ic) > 0){
    if(length(lijst_vrije_plekken_ic) ==0){
      # als er geen vrije plekken meer zijn stuur alles naar het buitenland
      verplaatsingsmatrix_ic[colnames(nodige_verplaatsingen_ic), 'Buitenland'] = t(copy_nodige_verplaatsingen_ic)
      copy_nodige_verplaatsingen_ic                                            = c(0)
    }else{
      #sample random patient en bestemming
      regio_herkomst                                           = sample(lijst_nodige_verplaatsingen_ic,1)
      regio_bestemming                                         = sample(lijst_vrije_plekken_ic,1)
      verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] = verplaatsingsmatrix_ic[regio_herkomst, regio_bestemming] + 1
      
      #verwerk in sample lijsten
      lijst_nodige_verplaatsingen_ic                 = lijst_nodige_verplaatsingen_ic[-first(which(lijst_nodige_verplaatsingen_ic == regio_herkomst))]
      lijst_vrije_plekken_ic                         = lijst_vrije_plekken_ic[-first(which(lijst_vrije_plekken_ic == regio_bestemming))]
      
      #veiligheidsmarge
      if(length(lijst_vrije_plekken_ic) <= bedden_vrijgehouden){
        lijst_vrije_plekken_ic = list()
      }
      copy_nodige_verplaatsingen_ic[,regio_herkomst] = copy_nodige_verplaatsingen_ic[,regio_herkomst] - 1
    }
  }
  return(list(verplaatsingsmatrix_kl = verplaatsingsmatrix_kl, verplaatsingsmatrix_ic = verplaatsingsmatrix_ic))
}


