rm(list=ls())
source('R/utils.R')
require(reshape2)
require(tibbletime)
library(xtable)
library(scales)
library(tables)
library(cowplot)
  save_results = T
df_kpis_long_tot = c()
scens = c(1, 2, 3)
paths = c("scenario 1" = 'regionale_info/resultaten spreiding ziekenhuizen/simulaties original/',
          "scenario 2" = 'regionale_info/resultaten spreiding ziekenhuizen/simulaties revision haga = 0.7/',
          "scenario 3" = 'regionale_info/resultaten spreiding ziekenhuizen/simulaties revision lumc 0.99/')
filename_store = 'regionale_info/resultaten spreiding ziekenhuizen/res_tabel_spreiding_ziekenhuizen_alphas.tex'
# scens = c(1, 2)
# paths = c("horizon = $3$" = 'regionale_info/resultaten spreiding ziekenhuizen/simulaties original/', "horizon = $5$" = 'regionale_info/resultaten spreiding ziekenhuizen/simulaties revision hor = 5/')
# filename_store = 'regionale_info/resultaten spreiding ziekenhuizen/res_tabel_spreiding_ziekenhuizen_horizon.tex'

nsim = c()
for( i_scen in seq(length(scens))){
  
  path = paths[i_scen]
  files <- list.files(path = path ,pattern = '.rds')
  namen_engels = c("optimale verdeelsleutel" = names(paths)[i_scen] )
  kpis_tot = list()

  upper_bound_sims = 250
  namen_strategien = c( "optimale verdeelsleutel"   )
  names_kpis = c('Over-bed Days Ward ','Over-beds Ward ', 'Over-bed Days ICU ', 'Over-beds ICU ', 'Occupancy Ward', 'Occupancy ICU', 'Load Fraction')#
  # function_overbedden = function(v){sum(diff(sapply(v,function(x){max(x,0)}))[diff(sapply(v,function(x){max(x,0)}))>0])}
  function_overbedden = function(v){mean(sapply(v,function(x){max(x,0)}))}
  
  for(filename in files){
    print(filename)
    loadres = load_obj(paste0(path, filename))
    for(naam_strategie in namen_strategien){
      simresults  = loadres$simulatie_resultaten[[naam_strategie]]
      kpis_partial = c()
      for(res in simresults){
        row_results       = c()
        if(naam_strategie != 'regionaal ziekenhuis'){
          dagen_overbed_kl_detail = apply(res$df_bezetting %>% select(contains('Kliniek')) > res$df_capaciteit%>% select(contains('Kliniek')), 2, sum)
          dagen_overbedden_kl_tot = sum(apply(res$df_bezetting %>% select(contains('Kliniek')) > res$df_capaciteit%>% select(contains('Kliniek')), 1, any))
          dagen_overbed_ic_detail = apply(res$df_bezetting %>% select(contains('IC')) > res$df_capaciteit%>% select(contains('IC')), 2, sum)
          dagen_overbedden_ic_tot = sum(apply(res$df_bezetting %>% select(contains('IC')) > res$df_capaciteit%>% select(contains('IC')), 1, any))
          
          overbedden_kl_detail = apply(res$df_bezetting %>% select(contains('Kliniek')) - res$df_capaciteit%>% select(contains('Kliniek')), 2, function_overbedden)
          overbedden_kl_tot    = sum(overbedden_kl_detail)
          overbedden_ic_detail = apply(res$df_bezetting %>% select(contains('IC')) - res$df_capaciteit%>% select(contains('IC')), 2, function_overbedden)
          overbedden_ic_tot    = sum(overbedden_ic_detail)
          
          bezetting_kl_detail =  apply(res$df_bezetting %>% select(contains('Kliniek')),2,mean)
          bezetting_kl_tot    =  sum(bezetting_kl_detail)
          
          bezetting_ic_detail =  apply(res$df_bezetting %>% select(contains('IC')),2,mean)
          bezetting_ic_tot    =  sum(bezetting_ic_detail)
          
          verdeelsleutel_detail =  apply(res$df_verdeelsleutel[,-1],2,mean)
          verdeelsleutel_tot =  mean(verdeelsleutel_detail)
          
        }else{
          dagen_overbed_kl_detail = rep(NA,3)
          dagen_overbedden_kl_tot = apply(res$df_bezetting %>% select(contains('Kliniek')) > res$df_capaciteit%>% select(contains('Kliniek')), 2, sum)
          dagen_overbed_ic_detail = rep(NA,3)
          dagen_overbedden_ic_tot = apply(res$df_bezetting %>% select(contains('IC')) > res$df_capaciteit%>% select(contains('IC')), 2, sum)
          
          overbedden_kl_tot    = apply(res$df_bezetting %>% select(contains('Kliniek')) - res$df_capaciteit%>% select(contains('Kliniek')), 2, function_overbedden)
          overbedden_kl_detail = rep(NA,3)
          overbedden_ic_tot    = apply(res$df_bezetting %>% select(contains('IC')) - res$df_capaciteit%>% select(contains('IC')), 2, function_overbedden)
          overbedden_ic_detail = rep(NA,3)
          
          bezetting_kl_detail = rep(NA,3)
          bezetting_kl_tot = apply(res$df_bezetting %>% select(contains('Kliniek')),2,mean)
          
          bezetting_ic_detail = rep(NA,3)
          bezetting_ic_tot = apply(res$df_bezetting %>% select(contains('IC')),2,mean)
          
          verdeelsleutel_detal = rep(NA,3)
          verdeelsleutel_tot = apply(res$df_verdeelsleutel[,-1],2,mean)
          
          
        }
        row_results = c(dagen_overbed_kl_detail, dagen_overbedden_kl_tot, overbedden_kl_detail, overbedden_kl_tot, 
                        dagen_overbed_ic_detail, dagen_overbedden_ic_tot, overbedden_ic_detail, overbedden_ic_tot, bezetting_kl_detail, bezetting_kl_tot, bezetting_ic_detail, bezetting_ic_tot)
        
        if("Load Fraction" %in% names_kpis){
          row_results = c(row_results,  c(verdeelsleutel_detail, verdeelsleutel_tot))
        }
        kpis_partial = rbind(kpis_partial, row_results)
      }
      colnames(kpis_partial) = as.vector(sapply(names_kpis,
                                                function(name){sapply(names(res$data_start_zkh), function(name2){paste0(name, name2)})}))
      
      
      kpis_tot[[naam_strategie]] = rbind(kpis_tot[[naam_strategie]], kpis_partial)
      if(nrow(kpis_tot[[naam_strategie]])>upper_bound_sims){
        kpis_tot[[naam_strategie]] = head(kpis_tot[[naam_strategie]],upper_bound_sims)
      }
    }
  }
  nsim = c(nsim, dim(kpis_tot[[naam_strategie]])[1])
  df_means = c()
  df_radii = c()
  for(naam_strategie in namen_strategien){
    df_means = rbind(df_means, apply(kpis_tot[[naam_strategie]], 2, function(v){mean(as.numeric(v), na.rm = T)} ))
    df_radii = rbind(df_radii, apply(kpis_tot[[naam_strategie]], 2, function(v){qt(0.975, length(v)-1)*sd(as.numeric(v), na.rm = T)/sqrt(length(v[!is.na(v)]))}))
  }
  df_means_long = as_tibble(df_means) %>% add_column(policy = namen_engels[namen_strategien], .before = 1) %>% pivot_longer(-policy) %>% rename(mean = value)
  df_radii_long = as_tibble(df_radii) %>% add_column(policy = namen_engels[namen_strategien], .before = 1) %>% pivot_longer(-policy) %>% rename(radius = value)
  
  
  df_kpis_long                                 = df_means_long %>% left_join(df_radii_long, c('policy', 'name'))
  means_formatted                              =  gsub(" ", "\\\\phantom{0}", format(round(df_kpis_long$mean,2), nsmall = 2))
  radii_formatted                              =  gsub(' ', '\\\\phantom{0}', format(round(df_kpis_long$radius,2), nsmall = 2))
  df_kpis_long$value                           = sapply(1:length(means_formatted), function(i){paste0('$\\text{',means_formatted[i],' $\\pm$ ', radii_formatted[i], '}$')})
  df_kpis_long$value[is.na(df_kpis_long$mean)] = '$\\text{\\phantom{0.0000}-\\phantom{00.00}}$'
  df_kpis_long                                 = df_kpis_long %>% add_column(Hospital = rep(c('LUMC','Haga', 'GHZ', 'Region'), length(names_kpis)*length(namen_strategien))) %>%
    add_column(KPI = rep(rep(names_kpis, each = 4),length(namen_strategien)))
  df_kpis_long_tot = rbind(df_kpis_long_tot, df_kpis_long)
}
results_table <- tabular(RowFactor(Hospital, name = 'Hospital')*RowFactor(KPI, name = 'KPI') ~
                           Heading()*Factor(policy)*Heading()*(value)*Heading()*(toString)*
                           DropEmpty(empty=""),
                         data = df_kpis_long_tot)

perm = c(5,4,7,6,3,2,1)
results_table = results_table[c(perm + length(perm)*2, perm + length(perm),perm,  perm + length(perm)*3),]
results_table = head(results_table,-1)

# 
nsim
results_table
if(save_results){
  write(tables::latex.tabular(results_table)[[1]], file = filename_store)
}







